<?php

/**
 * @package Extension iubenda Cookie Law Solution for Joomla! greater than 2.5
 * @version 1.1.5
 * @author iubenda
 * @copyright (C) 2015- iubenda
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

 /**
 * version: 2.0.2
 * codename: iubendaFaster
 * @author: Copyright 2015 iubenda
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

	class iubendaFaster
	{
		/*
			Variables
		*/
		
		private $getBlack = array
		(
			array
			(
				"platform.twitter.com/widgets.js",
				"apis.google.com/js/plusone.js",
				"apis.google.com/js/platform.js",
				"connect.facebook.net",
				"www.youtube.com/iframe_api",
				"pagead2.googlesyndication.com/pagead/js/adsbygoogle.js",
				"sharethis.com/button/buttons.js",
				"addthis.com/js/",
				'window.adsbygoogle',
				"addthis.com/js/"
			),
			array
			(
				"youtube.com",
				"platform.twitter.com",
				"www.facebook.com/plugins/like.php",
				"www.facebook.com/plugins/likebox.php",
				"apis.google.com",
				"www.google.com/maps/embed/",
				"player.vimeo.com/video",
				"maps.google.it/maps",
				"www.google.com/maps/embed",
				'window.adsbygoogle',
				"www.google.com/maps/embed"
			)
		);
		
		/**/
		
		private $getBlank = "//cdn.iubenda.com/cookie_solution/empty.html";
		
		private $getClass = array("_iub_cs_activate", "_iub_cs_activate-inline");
		
		/*
			Methods
		*/
				
		public function isBlack($offender, $blacklist)
		{
			/*
				Check if a string is in the black list.
			*/
			
			if(empty($offender) || empty($blacklist)) {
						
				return false;
				
			}
			
			/**/
			
			foreach($blacklist as $black)
			{	
				if(strpos($offender, $black) !== false) {
					
					return true;
					
				}
			}
			
			/**/
			
			return false;
		}
		
		/**/
		
		public function isParse($offender)
		{	
			/*
				Parse the entrie document and search for black elements.
			*/
			
			libxml_use_internal_errors(true);
			
			/**/
			
			$src = "";
			
			$blank = $this -> getBlank;
			$class = $this -> getClass;
			
			$list_1 = $this -> getBlack[0];
			$list_2 = $this -> getBlack[1];
			
			$document = new DOMDocument();
			
			/**/
			
			$document -> formatOutput = true;
			$document -> preserveWhiteSpace = false;
			
			/**/
			
			$document -> loadHTML($offender);
			
			/**/
			
			$scripts = $document -> getElementsByTagName("script");
			$iframes = $document -> getElementsByTagName("iframe");
			
			/*
				Parse the founded elements and check who is in black.
			*/
			
			foreach($scripts as $script) {
				
				$src = $script -> getAttribute("src");
				
				/**/
				
				if($this -> isBlack($src, $list_1))
				{
					$script -> setAttribute("type", "text/plain");
					$script -> setAttribute("class", $script -> getAttribute("class")." ".$class[0]);
				}
				elseif($this -> isBlack($script -> nodeValue, $list_1))
				{
					$script -> setAttribute("type", "text/plain");
					$script -> setAttribute("class", $script -> getAttribute("class")." ".$class[1]);
				}
			}
			foreach($iframes as $iframe) {
				
				$src = $iframe -> getAttribute("src");
				
				/**/
				
				if($this -> isBlack($src, $list_2))
				{
					$iframe -> setAttribute("src", $blank);
					$iframe -> setAttribute("suppressedsrc", $src);
					$iframe -> setAttribute("class", $iframe -> getAttribute("class")." ".$class[0]);
				}
			}
			
			/**/
			
			$offender = $document -> saveHTML();
			
			/**/
			
			libxml_use_internal_errors(false);
			
			/**/
			
			return $offender;
		}
	}

/**/

defined("_JEXEC") || die();

/**/

jimport("joomla.plugin.plugin");
jimport("joomla.language.language");

/**/

class PlgSystemIubenda extends JPlugin
{
    function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
    
    function onAfterRender()
    {
        /*
         * Checking if user is guest or admin
        */
        
        if(isset($_GET["iub_no_parse"]) || isset($_SERVER["HTTP_X_REQUESTED_WITH"])) {
			
			return true;
			
        }
        
        /**/
		
		if(JFactory::getUser()->guest)
		{
			/*
			 * including iubenda class and simpleHTMLDom
			*/
			
			$content = JResponse::getBody();
			
			if(strpos($content, "<html") === false) {
			    return true;
			} else if(strpos($content, "<html") > 200) {
				return true;
			}
			
			if(!function_exists("file_get_html")) {
	            require(dirname(__FILE__)."/iubenda-cookie-class/simple_html_dom.php");
	        }
	       		        
			// require(dirname(__FILE__)."/iubenda-cookie-class/iubenda.class.faster.php");
	        require(dirname(__FILE__)."/iubenda-cookie-class/iubenda.class.php");
	        
	        $iubenda_parse = true;
	        
	        if($iubenda_parse)
	        {
	            $current_language = JFactory::getLanguage();
	            $current_tag = $current_language -> getTag();
	            
	            $iub_code = $this->params->get("iubenda-code-".$current_tag);
	            // $iub_code = preg_replace("#<(.*?)>#i", null, $iub_code);
	            // $iub_code = '<script type="text/javascript"> '.$iub_code." </script>";
	            $iub_code = str_replace("on-load", "onload", $iub_code);
	            
				$iub_code .="\n
					<script type='text/javascript'>
						var iCallback = function(){};

						if('callback' in _iub.csConfiguration) {
							if('onConsentGiven' in _iub.csConfiguration.callback) iCallback = _iub.csConfiguration.callback.onConsentGiven;

							_iub.csConfiguration.callback.onConsentGiven = function()
							{
								iCallback();

								/*
								 * Separator
								*/

								jQuery('noscript._no_script_iub').each(function (a, b) { var el = jQuery(b); el.after(el.html()); });
							};
						};
					</script>";

				$startime = microtime(true);
				
				if($this->params->get("iubenda-experimental-parser") == "1")
				{
					$faster = new iubendaFaster;
					
					$content = $faster -> isParse(mb_convert_encoding($content, "HTML-ENTITIES", "UTF-8"));
					
					$content .= "<!-- IUBENDA EXPERIMENTAL PARSING ENGINE -->";
				}
				else {
					
					$page = new iubendaPage($content);
					$page->parse();

	            	/**/
	                
	            	$content = $page->get_converted_page();
	            	
	            	$content .= "<!-- IUBENDA DEFAULT PARSING ENGINE -->";
	            	
				}
				
	            $content = str_replace("</head>", $iub_code."</head>", $content);
	            
	            JResponse::setBody($content."<!-- IUBENDA PLUGIN ACTIVE ".round(microtime(true) - $startime, 4)."s -->");
        	}
		}
		else
		{
		    $content = JResponse::getBody();
		    
		    if(strpos($content, "<html") === false) {
			    
			    return true;
			    
			} else if(strpos($content, "<html") > 200) {
				
				return true;
				
			}

			if(strpos($content, "attrib-iubenda-") !== false)
			{
			    $languages = JLanguage::getKnownLanguages();
			    
			    /*
			     * Bigger textarea
			    */
			    
			    $style = ".iubenda-textarea { width: 80%; min-height: 300px; }";
			    
			    /*
			     * Separator
			    */
			    
			    $tabs = array("it-IT", "de-DE", "en-GB", "es-ES", "br-BR", "ru-RU", "pt-BR", "nl-NL", "fr-FR");
			    
			    /*
			     * Removing the Tabs
			    */
			    
			    foreach($languages as $tag => $lang) {
			        $tabs = array_diff($tabs, array($tag));
			    }
			    foreach($tabs as $tab) {
			        $style .= ' a[href="#'.$tab.'"] { display: none !important; } ';
			    }
			    
			    /* Finished */
			    
			    $content = str_replace("</head>", "<style>".$style."</style></head>", $content);
			    
			    JResponse::setBody($content."<!-- IUBENDA PLUGIN ACTIVE -->");
			}
		}
        
        return true;
    }
}

?>